Programming C, C++, Java, PHP, Ruby, Turing, VB
Computer Science Canada 
Programming C, C++, Java, PHP, Ruby, Turing, VB  

Username:   Password: 
 RegisterRegister   
 Dynamic Programing
Index -> Programming, Java -> Java Help
View previous topic Printable versionDownload TopicSubscribe to this topicPrivate MessagesRefresh page View next topic
Author Message
blackhawk_prince




PostPosted: Sat Jul 19, 2008 7:16 am   Post subject: Dynamic Programing

Hi I current trying to write code for a USACO question.
----------------------------------------------------------------------------------------
You have a necklace of N red, white, or blue beads (3<=N<=350) some of which are red, others blue, and others white, arranged at random. Here are two examples for n=29:

1 2 1 2
r b b r b r r b
r b b b
r r b r
r r w r
b r w w
b b r r
b b b b
b b r b
r r b r
b r r r
b r r r
r r r b
r b r r r w
Figure A Figure B
r red bead
b blue bead
w white bead

The beads considered first and second in the text that follows have been marked in the picture.

The configuration in Figure A may be represented as a string of b's and r's, where b represents a blue bead and r represents a red one, as follows: brbrrrbbbrrrrrbrrbbrbbbbrrrrb .

Suppose you are to break the necklace at some point, lay it out straight, and then collect beads of the same color from one end until you reach a bead of a different color, and do the same for the other end (which might not be of the same color as the beads collected before this).

Determine the point where the necklace should be broken so that the most number of beads can be collected.
Example

For example, for the necklace in Figure A, 8 beads can be collected, with the breaking point either between bead 9 and bead 10 or else between bead 24 and bead 25.

In some necklaces, white beads had been included as shown in Figure B above. When collecting beads, a white bead that is encountered may be treated as either red or blue and then painted with the desired color. The string that represents this configuration will include the three symbols r, b and w.

Write a program to determine the largest number of beads that can be collected from a supplied necklace.
PROGRAM NAME: beads
INPUT FORMAT
Line 1: N, the number of beads
Line 2: a string of N characters, each of which is r, b, or w
SAMPLE INPUT (file beads.in)

29
wwwbbrwrbrbrrbrbrwrwwrbwrwrrb

OUTPUT FORMAT
A single line containing the maximum of number of beads that can be collected from the supplied necklace.
SAMPLE OUTPUT (file beads.out)

11

OUTPUT EXPLANATION
Consider two copies of the beads (kind of like being able to runaround the ends). The string of 11 is marked.

wwwbbrwrbrbrrbrbrwrwwrbwrwrrb wwwbbrwrbrbrrbrbrwrwwrbwrwrrb
****** *****
--------------------------------------------------------------------------------------------------------
I got the code working using recursion. How would I solve this using dynamic programing? Also could someone post a turotrial on how to use dynamic program. I have enough knowledge to know where I can use dynamic program just not HOW to use it.
Thx Smile
Sponsor
Sponsor
Sponsor
sponsor
blackhawk_prince




PostPosted: Sat Jul 19, 2008 7:20 am   Post subject: RE:Dynamic Programing

srry the my post get messed up. The beads were supposed to be in a necklace shape but compsic.ca left aligned everything. But i hope you guys got the general idea.
apomb




PostPosted: Sat Jul 19, 2008 10:43 am   Post subject: RE:Dynamic Programing

[code]tags work
CodeMonkey2000




PostPosted: Sat Jul 19, 2008 3:33 pm   Post subject: RE:Dynamic Programing

This doesn't even need DP, just simulate it. But the DP solution involves creating 2 arrays, one contains the beads in the proper order, and the other in the reverse order.
blackhawk_prince




PostPosted: Sat Jul 19, 2008 7:34 pm   Post subject: RE:Dynamic Programing

"This doesn't even need DP, just simulate it. "
What does that mean!? Explain.
DemonWasp




PostPosted: Mon Jul 21, 2008 8:25 am   Post subject: RE:Dynamic Programing

N <= 350

^ That says all that you need to know. Just code it the naive way! With N so small, the problem should execute in trivial time, even when doing this the naive way. Just consider each of the <=350 cut points, and determine the "value" of each. Choose the best one...problem solved.
Display posts from previous:   
   Index -> Programming, Java -> Java Help
View previous topic Tell A FriendPrintable versionDownload TopicSubscribe to this topicPrivate MessagesRefresh page View next topic

Page 1 of 1  [ 6 Posts ]
Jump to:   


Style:  
Search: